SystemOrganization addCategory: #RatPack!
SystemOrganization addCategory: #'RatPack-Templating'!
SystemOrganization addCategory: #'RatPack-UI'!

HttpService subclass: #RPApplication
	instanceVariableNames: 'rpCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RatPack'!

!RPApplication class methodsFor: 'instance creation' stamp: 'tfel 1/31/2012 18:25'!
debug

	^ self runIn: #debug on: 4567 named: 'RatPack'! !

!RPApplication class methodsFor: 'constants' stamp: 'tfel 2/13/2012 08:48'!
defaultMode

	^ #deployment! !

!RPApplication class methodsFor: 'constants' stamp: 'tfel 2/13/2012 08:48'!
defaultName

	^ 'RatPack'! !

!RPApplication class methodsFor: 'constants' stamp: 'tfel 2/13/2012 08:47'!
defaultPort

	^ 4567! !

!RPApplication class methodsFor: 'constants' stamp: 'tfel 2/2/2012 09:18'!
errorPage

	^ '<!!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
<title><%= anException class %> at <%= self request url %></title>

<script type="text/javascript">
//<!!--
function toggle(id) {
var pre = document.getElementById("pre-" + id);
var post = document.getElementById("post-" + id);
var context = document.getElementById("context-" + id);

if (pre.style.display == ''block'') {
pre.style.display = ''none'';
context.style.background = "none";
} else {
pre.style.display = ''block'';
context.style.background = "#fffed9";
}
}

function toggleBacktrace(){
var bt = document.getElementById("backtrace");
var toggler = document.getElementById("expando");

if (bt.className == ''condensed'') {
bt.className = ''expanded'';
toggler.innerHTML = "(condense)";
} else {
bt.className = ''condensed'';
toggler.innerHTML = "(expand)";
}
}
//-->
</script>

<style type="text/css" media="screen">
* {margin: 0; padding: 0; border: 0; outline: 0;}
div.clear {clear: both;}
body {background: #EEEEEE; margin: 0; padding: 0;
font-family: ''Lucida Grande'', ''Lucida Sans Unicode'',
''Garuda'';}
code {font-family: ''Lucida Console'', monospace;
font-size: 12px;}
li {height: 18px;}
ul {list-style: none; margin: 0; padding: 0;}
ol:hover {cursor: pointer;}
ol li {white-space: pre;}
#explanation {font-size: 12px; color: #666666;
margin: 20px 0 0 100px;}
/* WRAP */
#wrap {width: 1000px; background: #FFFFFF; margin: 0 auto;
padding: 30px 50px 20px 50px;
border-left: 1px solid #DDDDDD;
border-right: 1px solid #DDDDDD;}
/* HEADER */
#header {margin: 0 auto 25px auto;}
#header img {float: left;}
#header #summary {float: left; margin: 12px 0 0 20px; width:660px;
font-family: ''Lucida Grande'', ''Lucida Sans Unicode'';}
h1 {margin: 0; font-size: 36px; color: #981919;}
h2 {margin: 0; font-size: 22px; color: #333333;}
#header ul {margin: 0; font-size: 12px; color: #666666;}
#header ul li strong{color: #444444;}
#header ul li {display: inline; padding: 0 10px;}
#header ul li.first {padding-left: 0;}
#header ul li.last {border: 0; padding-right: 0;}
/* BODY */
#backtrace,
#get,
#post,
#cookies,
#rack {width: 980px; margin: 0 auto 10px auto;}
p#nav {float: right; font-size: 14px;}
/* BACKTRACE */
a#expando {float: left; padding-left: 5px; color: #666666;
font-size: 14px; text-decoration: none; cursor: pointer;}
a#expando:hover {text-decoration: underline;}
h3 {float: left; width: 100px; margin-bottom: 10px;
color: #981919; font-size: 14px; font-weight: bold;}
#nav a {color: #666666; text-decoration: none; padding: 0 5px;}
#backtrace li.frame-info {background: #f7f7f7; padding-left: 10px;
font-size: 12px; color: #333333;}
#backtrace ul {list-style-position: outside; border: 1px solid #E9E9E9;
border-bottom: 0;}
#backtrace ol {width: 920px; margin-left: 50px;
font: 10px ''Lucida Console'', monospace; color: #666666;}
#backtrace ol li {border: 0; border-left: 1px solid #E9E9E9;
padding: 2px 0;}
#backtrace ol code {font-size: 10px; color: #555555; padding-left: 5px;}
#backtrace-ul li {border-bottom: 1px solid #E9E9E9; height: auto;
padding: 3px 0;}
#backtrace-ul .code {padding: 6px 0 4px 0;}
#backtrace.condensed .system,
#backtrace.condensed .framework {display:none;}
/* REQUEST DATA */
p.no-data {padding-top: 2px; font-size: 12px; color: #666666;}
table.req {width: 980px; text-align: left; font-size: 12px;
color: #666666; padding: 0; border-spacing: 0;
border: 1px solid #EEEEEE; border-bottom: 0;
border-left: 0;
clear:both}
table.req tr th {padding: 2px 10px; font-weight: bold;
background: #F7F7F7; border-bottom: 1px solid #EEEEEE;
border-left: 1px solid #EEEEEE;}
table.req tr td {padding: 2px 20px 2px 10px;
border-bottom: 1px solid #EEEEEE;
border-left: 1px solid #EEEEEE;}
/* HIDE PRE/POST CODE AT START */
.pre-context,
.post-context {display: none;}

table td.code {width:750px}
table td.code div {width:750px;overflow:hidden}
</style>
</head>
<body>

<% startContext := anException signalerContext 
   		   	       ifNotNilDo: [:ctxt | ctxt]
				ifNil: [thisContext]. %>

<div id="wrap">
<div id="header">
<img src="<%= self request url %>/__sinatra__/500.png" alt="application error" height="161" width="313" />
<div id="summary">
<h1><strong><%= anException class %></strong> at <strong><%= self request url %>
</strong></h1>
<h2><%= anException messageText  %></h2>
<ul>
<li class="first"><strong>file:</strong> <code>
<%= startContext methodClass  %></code></li>
<li><strong>location:</strong> <code><%= startContext selector  %>
</code></li>
<li class="last"><strong>line:
</strong> <%= startContext pc %></li>
</ul>
</div>
<div class="clear"></div>
</div>

<div id="backtrace" class=''condensed''>
<h3>BACKTRACE</h3>
<p><a href="#" id="expando"
onclick="toggleBacktrace(); return false">(expand)</a></p>
<p id="nav"><strong>JUMP TO:</strong>
<a href="#get-info">GET</a>
<a href="#post-info">POST</a>
<a href="#cookie-info">COOKIES</a>
<a href="#env-info">ENV</a>
</p>
<div class="clear"></div>

<ul id="backtrace-ul">

<% id := 1. %>
<% (startContext stackOfSize: 100) do: [:frame| %>

<li class="frame-info <%= frame methodClass %>">
<code><%= frame methodClass %></code> in
<code><strong><%= frame selector %></strong></code>
</li>

<li class="code <%= frame methodClass %>">
<ol start="<%= 1 %>"
class="pre-context" id="pre-<%= id %>"
onclick="toggle(<%= id %>);">
<% frame tempNames doWithIndex: [:title :index | %>
<li class="pre-context-line"><code><%= (title asString, 
    $: asString, Character space asString,
    (([frame tempAt: index] on: Error do: [nil]) printStringLimitedTo: (160 - 3 - title size max: 1))) asHtml %></code></li>
<% ]. %>
</ol>

<ol start="<%= frame pc %>" class="context" id="<%= id %>"
onclick="toggle(<%= id %>);">
<li class="context-line" id="context-<%= id %>"><code><%= frame sourceCode asString asHtml %></code></li>
</ol>

<div class="clear"></div>
</li>

<% id := id + 1. %>
<% ]. %>

</ul>
</div> <!!-- /BACKTRACE -->

<div id="get">
<h3 id="get-info">GET</h3>
<% self request method = ''GET'' ifTrue: [ %>
<table class="req">
<tr>
<th>Variable</th>
<th>Value</th>
</tr>
<% self request getFields associationsDo: [:assoc| %>
<tr>
<td><%= assoc key asString asHtml %></td>
<td class="code"><div><%= assoc value printString asHtml %></div></td>
</tr>
<% ]. %>
</table>
<% ] ifFalse: [ %>
<p class="no-data">No GET data.</p>
<% ]. %>
<div class="clear"></div>
</div> <!!-- /GET -->

<div id="post">
<h3 id="post-info">POST</h3>
<% self request method = ''POST'' ifTrue: [ %>
<table class="req">
<tr>
<th>Variable</th>
<th>Value</th>
</tr>
<% self request postFields associationsDo: [:assoc| %>
<tr>
<td><%= assoc key asString asHtml %></td>
<td class="code"><div><%= assoc value printString asHtml %></div></td>
</tr>
<% ]. %>
</table>
<% ] ifFalse: [ %>
<p class="no-data">No POST data.</p>
<% ]. %>
<div class="clear"></div>
</div> <!!-- /POST -->

<div id="cookies">
<h3 id="cookie-info">COOKIES</h3>
<% self request cookies isEmpty ifFalse: [ %>
<table class="req">
<tr>
<th>Variable</th>
<th>Value</th>
</tr>
<% self request cookies associationsDo: [:assoc| %>
<tr>
<td><%= assoc key asString asHtml %></td>
<td class="code"><div><%= assoc value printString asHtml %></div></td>
</tr>
<% ]. %>
</table>
<% ] ifTrue: [ %>
<p class="no-data">No cookie data.</p>
<% ]. %>
<div class="clear"></div>
</div> <!!-- /COOKIES -->

<p id="explanation">You''re seeing this error because you have
enabled the <code>deployment</code> mode.</p>
</div> <!!-- /WRAP -->
</body>
</html>'! !

!RPApplication class methodsFor: 'constants' stamp: 'tfel 2/1/2012 18:55'!
notFoundPage

	 ^ '<!!DOCTYPE html>
<html>
<head>
<style type="text/css">
body {
	text-align: center;
	font-family: helvetica,arial;
	font-size: 22px;
	color: #888;
	margin:20px
}
#c {
	margin: 0 auto;
	width: 500px;
	text-align: left
}
.methodName { color: black; }
.pragmaKey { color: green; }
.string { color: purple; }
.return { color: darkRed; }
</style>
</head>
<body>
<h2>The Rat Pack doesn&rsquo;t appear in this flick.</h2>
<div id="c">
Try this:
<pre>
<span class="methodName">handleRequestFor<%=

	(self request pathParts ifNil: [#('''')]) inject: '''' into: [:acc :next | acc, next capitalized]
	
%>
</span>
  &lt;<span class="pragmaKey"><%=

self request method asLowercase 

%></span>: <span class="string">''<%=

self request url

%>''</span>&gt;
  <span class="return">^</span> <span class="string">''Hello World''</span>
</pre>
</div>
<div id="c">
Or that:
<pre>
<span class="methodName">handleRequestFor<%=

	(self request pathParts ifNil: [#('''')]) inject: '''' into: [:acc :next | acc, next capitalized]

%>: argument</span>
  &lt;<span class="pragmaKey"><%=

self request method asLowercase

%></span>: <span class="string">''<%=

	self request pathParts isEmpty
		ifTrue: [''(.*)'']
		ifFalse: [(self request pathParts allButLast inject: '''' into: [:acc :next | acc, ''/'', next]), ''/%'']

%>''</span>&gt;
  <span class="return">^</span> <span class="string">''Hello ''</span>, argument
</pre>
</div>
<% self request pathParts ifNotEmpty: [ %>
<div id="c">
Or even this:
<pre>
<span class="methodName">handleRequestFor<%=

	(self request pathParts ifNil: [#('''')]) inject: '''' into: [:acc :next | acc, next capitalized]

%>: argument</span>
  &lt;<span class="pragmaKey"><%=

self request method asLowercase

%></span>: <span class="string">''<%=

	(self request pathParts allButLast inject: '''' into: [:acc :next | acc, ''/'', next]), ''/(.+)''

%>''</span>&gt;
  <span class="return">^</span> <span class="string">''Hello ''</span>, argument
</pre>
</div>
<% ]. %>
</body>
</html>'
! !

!RPApplication class methodsFor: 'constants' stamp: 'tfel 1/31/2012 13:43'!
requestKey

	^ #rpRequest! !

!RPApplication class methodsFor: 'constants' stamp: 'tfel 1/31/2012 13:43'!
responseKey

	^ #rpResponse! !

!RPApplication class methodsFor: 'accessing' stamp: 'tfel 2/1/2012 16:21'!
routes

	^ Array streamContents: [:stream |
		#(get: #put: #post: #delete: #patch: #head: #options: #trace: #connect:) do: [:verb |
			stream nextPutAll: (Pragma allNamed: verb from: self to: RPApplication)]]! !

!RPApplication class methodsFor: 'instance creation' stamp: 'tfel 2/13/2012 08:48'!
run

	^ self runIn: self defaultMode on: self defaultPort named: self defaultName! !

!RPApplication class methodsFor: 'instance creation' stamp: 'tfel 1/31/2012 18:24'!
runIn: mode on: aPort named: aString
	| service |
	service := self on: aPort named: aString.
	^ service
		mode: mode;
		onRequestDo: [:httpRequest | service processRequest: httpRequest];
		start;
		yourself
! !

!RPApplication class methodsFor: 'accessing' stamp: 'tfel 2/1/2012 10:05'!
services

	^ super services select: [:service | service isKindOf: self]! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 12:15'!
attachment: aFilename

	| attachmentHeader |
	attachmentHeader := 'attachment; filename="', (FileDirectory localNameFor: aFilename), '"'.
	self response headers: {'Content-Disposition' -> attachmentHeader}.
	(FileDirectory default mimeTypesFor: aFilename) ifNotNilDo: [:mimeTypes |
		self response headers: {'Content-Type' -> mimeTypes first}].
! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 12:00'!
body
	
	^ self response contents
! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 12:03'!
body: aStringOrStream

	self response contents: (aStringOrStream isStream
		ifTrue: [aStringOrStream]
		ifFalse: [ReadStream on: aStringOrStream]).! !

!RPApplication methodsFor: 'private' stamp: 'tfel 2/15/2012 15:12:13.647'!
cache: aBlock as: aSymbol

	^ rpCache at: aSymbol ifAbsentPut: aBlock value! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 11:56'!
contentType

	^ (self threadLocal: self class responseKey) contentType! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 12:04'!
contentType: aString

	^ self response contentType: aString! !

!RPApplication methodsFor: 'templating' stamp: 'tfel 2/13/2012 11:41'!
est: aString
	"Slow, because it reifies the stack, but allows access to arguments and temps"
	^ RPEmbeddedSmalltalk render: aString in: thisContext sender! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 12:02'!
headers

	^ self response fields! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 12:02'!
headers: aDictionary

	self response fields addAll: aDictionary.! !

!RPApplication methodsFor: 'actions' stamp: 'tfel 2/1/2012 18:59'!
notFound
	self contentType: 'text/html'.
	self status: 404.
	^ self est: self class notFoundPage! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 2/15/2012 15:10:41.43'!
params
	"Replaces param keys that have only one value with the value,
	so we don't have to deal with arrays all over the place"
	^ self
		cache: [Dictionary new
					addAll: (Array streamContents: [:stream |
								self request fields keysAndValuesDo: [:key :value |
									stream nextPut: (key -> (value size = 1
																ifTrue: [value first]
																ifFalse: [value]))]])]
		as: #params! !

!RPApplication methodsFor: 'routing' stamp: 'tfel 1/31/2012 19:01'!
processRequest: aHttpRequest
	| response |
	Processor activeProcess
		environmentAt: self class requestKey put: aHttpRequest;
		environmentAt: self class responseKey put: HttpResponse new.
	response := [self route: aHttpRequest] on: Error do: [:e | self serverError: e].
	response isString ifFalse: [response := ''].
	(self status = 404 and: [response isEmpty]) ifTrue: [response := self notFound].
	self body: response.
	^ self response
! !

!RPApplication methodsFor: 'actions' stamp: 'tfel 1/31/2012 12:17'!
redirectBack

	self redirectTo: self request referer.! !

!RPApplication methodsFor: 'actions' stamp: 'tfel 2/1/2012 11:50'!
redirectTo: aString

	self
		status: 302;
		contentType: MIMEDocument contentTypeHtml;
		body: 'Temporarily moved to: <A HREF="', aString, '">', aString, '</A>';
		headers: {'Location' -> aString asString copy. 'URI' -> aString asString copy}
! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 11:40'!
request
	
	^ self threadLocal: self class requestKey
! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 11:59'!
response
	
	^ self threadLocal: self class responseKey
! !

!RPApplication methodsFor: 'routing' stamp: 'tfel 1/31/2012 21:09'!
route: aHttpRequest
	| arguments result method |
	method := aHttpRequest method asLowercase asSymbol asMutator.
	arguments := (((Pragma allNamed: method from: self class to: RPApplication)
					collect: [:pragma || rx |
						rx := RxMatcher forString: ((pragma argumentAt: 1)
														copyReplaceAll: '%'
														with: '([^/]+)').
						(rx matches: aHttpRequest url)
							ifTrue: [pragma -> rx subexpressions allButFirst]
							ifFalse: [nil]])
					reject: [:assoc | assoc isNil])
					sortBy: [:a :b | a value size < b value size].
	arguments ifEmpty: [self status: 404. ^ ''].
	result := arguments first key method
				valueWithReceiver: self
				arguments: arguments first value.
	^ result isString ifTrue: [result] ifFalse: [self body]
! !

!RPApplication methodsFor: 'actions' stamp: 'tfel 2/13/2012 11:29'!
serverError: anException

	self contentType: 'text/html'.
	self status: 500.
	self isDebugMode ifTrue: [anException signal].
	^ self est: self class errorPage
! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 11:57'!
status
	
	^ (self threadLocal: self class responseKey) statusCode asInteger
! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 11:59'!
status: aSymbolOrInteger

	self response status: (aSymbolOrInteger isSymbol
		ifTrue: [aSymbolOrInteger]
		ifFalse: [HttpResponse statusSymbolFor: aSymbolOrInteger]).
! !

!RPApplication methodsFor: 'private' stamp: 'tfel 1/31/2012 13:56'!
threadLocal: aSymbol
	
	^ Processor activeProcess environmentAt: aSymbol ifAbsent: []
! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 2/15/2012 12:01:24.47'!
url
	^ String streamContents: [:stream |
		stream nextPutAll: 'http://'.
		stream nextPutAll: self request host]
! !

SystemWindow subclass: #RPControlPanel
	instanceVariableNames: 'applicationIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RatPack-UI'!

!RPControlPanel commentStamp: 'tfel 2/1/2012 16:05' prior: 0!
The RPControlPanel can be used to manage RPApplications.
Open it from the world menu or with:
	RPControlPanel open!

!RPControlPanel class methodsFor: 'strings' stamp: 'tfel 2/1/2012 15:37'!
appClassChooserString

	^ 'Choose the application class' translated! !

!RPControlPanel class methodsFor: 'strings' stamp: 'tfel 2/1/2012 15:38'!
appNameChooserString

	^ 'Application Name' translated! !

!RPControlPanel class methodsFor: 'constants' stamp: 'tfel 2/1/2012 15:35'!
initialWindowExtent

	^ 400@300! !

!RPControlPanel class methodsFor: 'menu key map' stamp: 'tfel 2/1/2012 16:11'!
menuKeyMap
	"Menu with always shown items in the first array, items that apply to a selected service 
	in the second. Items take the form {key . label . help . action}.
	If the label is a symbol, a label selector is assumed and an updating menu item is used.
	If key is nil, there will be no keybinding.
	For string labels, the keybinding is added in parens."
	^ #(
		#(
			$a 'Add' 'Add an application' addApplication
		)
		#(
			$s runningString 'Start/stop the application' toggleRunning
			$E 'Explore' 'Explore the application' exploreObject
			$m 'Set mode' 'Set the application mode' setMode
			$p 'Set port' 'Set the application port' setPort
			$n 'Set name' 'Set the application name' setName
			nil 'Remove' 'Remove the application' removeApplication
		)
	)! !

!RPControlPanel class methodsFor: 'instance creation' stamp: 'tfel 2/1/2012 10:01'!
open

	^ self new
		openInWorld;
		yourself! !

!RPControlPanel class methodsFor: 'strings' stamp: 'tfel 2/1/2012 15:38'!
portString

	^ 'Port' translated! !

!RPControlPanel class methodsFor: 'strings' stamp: 'tfel 2/1/2012 16:08'!
startString

	^ 'Start' translated, ' (s)'! !

!RPControlPanel class methodsFor: 'strings' stamp: 'tfel 2/1/2012 16:09'!
stopString

	^ 'Stop' translated, ' (s)'! !

!RPControlPanel class methodsFor: 'strings' stamp: 'tfel 2/1/2012 15:45'!
windowTitle

	^ 'RatPack ', 'Browser' translated, ' ', 'Window' translated! !

!RPControlPanel methodsFor: 'actions' stamp: 'tfel 2/13/2012 08:51'!
addApplication
	| labels class |
	labels := RPApplication withAllSubclasses collect: [:each | each name].
	class := (UIManager default
				chooseFrom: labels
				values: RPApplication withAllSubclasses
				lines: #()
				title: self class appClassChooserString) ifNil: [^ self].
	class
		runIn: class defaultMode
		on: ((UIManager default
					request: self class portString
					initialAnswer: class defaultPort asString) ifEmpty: [^ self]) asInteger
		named: ((UIManager default
					request: self class appNameChooserString
					initialAnswer: class defaultName asString) ifEmpty: [^ self]).
	self applicationIndex: self applicationList size.
	self change.! !

!RPControlPanel methodsFor: 'accessing' stamp: 'tfel 2/1/2012 10:04'!
applicationIndex
	"Answer the value of applicationIndex"

	^ applicationIndex! !

!RPControlPanel methodsFor: 'accessing' stamp: 'tfel 2/1/2012 10:49'!
applicationIndex: anObject
	"Set the value of applicationIndex"

	applicationIndex := anObject.
	self change.! !

!RPControlPanel methodsFor: 'accessing' stamp: 'tfel 2/1/2012 16:19'!
applicationInspect

	self selectedApplication ifNil: [^ ''].
	^ 'routes: ', self selectedApplication class routes printString, Character cr,
		'mode: ', self selectedApplication mode printString, Character cr! !

!RPControlPanel methodsFor: 'accessing' stamp: 'tfel 2/1/2012 10:09'!
applicationList

	^ RPApplication services asOrderedCollection! !

!RPControlPanel methodsFor: 'menu' stamp: 'tfel 2/1/2012 15:59'!
applicationMenu: aMenu shifted: shift

	aMenu setTarget: self.
	self fillApplicationMenu: aMenu from: self class menuKeyMap first.
	self selectedApplication ifNotNil: [
		aMenu addLine.
		self fillApplicationMenu: aMenu from: self class menuKeyMap second].
	^ aMenu! !

!RPControlPanel methodsFor: 'initialization' stamp: 'tfel 2/1/2012 15:40'!
buildApplicationDetail

	self
		addMorph: (PluggableTextMorph new
						on: self 
						text: #applicationInspect
						accept: nil
						readSelection: nil
						menu: nil;
						width: self width;
						height: self height / 2;
						topLeft: self height / 2 + self topLeft)
		fullFrame: (LayoutFrame fractions: (0@0.5 corner: 1@1)).
! !

!RPControlPanel methodsFor: 'initialization' stamp: 'tfel 2/1/2012 13:42'!
buildApplicationList

	self
		addMorph: (PluggableListMorph new
						on: self
						list: #applicationList
						selected: #applicationIndex
						changeSelected: #applicationIndex:
						menu: #applicationMenu:shifted:
						keystroke: #handleShortcut:;
						width: self width;
						height: self height / 2;
						topLeft: self topLeft)
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@0.49)).! !

!RPControlPanel methodsFor: 'change reporting' stamp: 'tfel 2/1/2012 10:33'!
change

	self
		changed: #applicationList;
		changed: #applicationIndex;
		changed: #applicationInspect.! !

!RPControlPanel methodsFor: 'actions' stamp: 'tfel 2/1/2012 10:26'!
exploreObject

	self selectedApplication explore.! !

!RPControlPanel methodsFor: 'menu' stamp: 'tfel 2/1/2012 16:08'!
fillApplicationMenu: aMenu from: aSpecificationList

	aSpecificationList groupsOf: 4 atATimeDo: [:key :label :help :action |
		label isSymbol
			ifFalse: [aMenu add: (key ifNil: [label] ifNotNil: [label, ' (', key, ')']) action: action]
			ifTrue: [aMenu addUpdating: label action: action].
		 aMenu balloonTextForLastItem: help].
! !

!RPControlPanel methodsFor: 'event handling' stamp: 'tfel 2/1/2012 16:05'!
handleShortcut: aChar
	| keyMap |
	keyMap := Dictionary new.
	self class menuKeyMap first groupsOf: 4 atATimeDo: [:key :label :help :action |
		keyMap at: key put: action].
	self selectedApplication ifNotNil: [
		self class menuKeyMap second groupsOf: 4 atATimeDo: [:key :label :help :action |
			keyMap at: key put: action]].
	self perform: (keyMap at: aChar ifAbsent: [#yourself]).! !

!RPControlPanel methodsFor: 'open/close' stamp: 'tfel 2/1/2012 15:35'!
initialExtent

	^ self class initialWindowExtent! !

!RPControlPanel methodsFor: 'initialization' stamp: 'tfel 2/1/2012 15:47'!
initialize

	super initialize.
	self
		setLabel: self class windowTitle;
		applicationIndex: 0;
		layoutPolicy: ProportionalLayout new;
		buildApplicationList;
		buildApplicationDetail.! !

!RPControlPanel methodsFor: 'actions' stamp: 'tfel 2/1/2012 10:52'!
removeApplication

	RPApplication removeService: self selectedApplication
										stop;
										yourself.
	self change.! !

!RPControlPanel methodsFor: 'accessing' stamp: 'tfel 2/1/2012 15:47'!
runningString

	^ self selectedApplication
		ifNil: ['']
		ifNotNilDo: [:app |
			app isRunning ifTrue: [self class stopString] ifFalse: [self class startString]]! !

!RPControlPanel methodsFor: 'accessing' stamp: 'tfel 2/1/2012 10:26'!
selectedApplication

	^ self applicationList at: self applicationIndex ifAbsent: []! !

!RPControlPanel methodsFor: 'actions' stamp: 'tfel 2/1/2012 10:57'!
setMode

	self selectedApplication
		mode: ((UIManager default
				chooseFrom: #(deployment debug)
				values: #(deployment debug)) ifNil: [^ self]).
	self change.! !

!RPControlPanel methodsFor: 'actions' stamp: 'tfel 2/1/2012 15:39'!
setName

	self selectedApplication
		name: ((UIManager default
						request: self class appNameChooserString
						initialAnswer: self selectedApplication name) ifEmpty: [^ self]).
	self change.! !

!RPControlPanel methodsFor: 'actions' stamp: 'tfel 2/1/2012 15:47'!
setPort

	self selectedApplication
		portNumber: ((UIManager default
						request: self class portString
						initialAnswer: self selectedApplication portNumber asString)
							ifEmpty: [^ self]) asInteger.
	self change.! !

!RPControlPanel methodsFor: 'actions' stamp: 'tfel 2/1/2012 10:44'!
toggleRunning

	self selectedApplication isRunning
		ifTrue: [self selectedApplication stop]
		ifFalse: [self selectedApplication start].
	self change.! !

Object subclass: #RPEmbeddedSmalltalk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RatPack-Templating'!

!RPEmbeddedSmalltalk class methodsFor: 'compiling' stamp: 'tfel 2/1/2012 19:06'!
convertToCode: aString
	"Converts the embedded smalltalk code into string concatenation with"
	| rs |
	rs := ReadStream on: aString.
	^ String streamContents: [:stream |
		self writePreambleFor: aString on: stream.
		[self renderLiteralStringFrom: rs to: stream.
		rs atEnd ifFalse: [self renderCodeFrom: rs to: stream].
		rs atEnd] whileFalse.
		self writePostscriptTo: stream]
! !

!RPEmbeddedSmalltalk class methodsFor: 'rendering' stamp: 'tfel 2/1/2012 18:54'!
render: aString 

	^ self evaluate: aString for: nil! !

!RPEmbeddedSmalltalk class methodsFor: 'rendering' stamp: 'tfel 2/1/2012 18:54'!
render: aString for: anObject

	^ Compiler new evaluate: (self convertToCode: aString) for: anObject logged: false! !

!RPEmbeddedSmalltalk class methodsFor: 'rendering' stamp: 'tfel 2/1/2012 18:54'!
render: aString in: aContext

	^ Compiler new evaluate: (self convertToCode: aString) in: aContext to: aContext receiver! !

!RPEmbeddedSmalltalk class methodsFor: 'compiling' stamp: 'tfel 2/2/2012 08:59'!
renderCodeFrom: rs to: stream
	| isInsert |
	(isInsert := rs peekFor: $=) ifTrue: [stream nextPutAll: 'r00t nextPutAll: ('].
	stream nextPutAll: (rs upToAll: '%>').
	isInsert ifTrue: [stream nextPutAll: ') asString.'].
	stream nextPut: Character cr.
! !

!RPEmbeddedSmalltalk class methodsFor: 'compiling' stamp: 'tfel 2/1/2012 19:04'!
renderLiteralStringFrom: rs to: stream

	stream
		nextPutAll: 'r00t nextPutAll: ';
		nextPutAll: (rs upToAll: '<%') printString;
		nextPut: $.;
		nextPut: Character cr.
! !

!RPEmbeddedSmalltalk class methodsFor: 'compiling' stamp: 'tfel 2/1/2012 19:06'!
writePostscriptTo: stream

	stream nextPutAll: 'r00t contents.'.! !

!RPEmbeddedSmalltalk class methodsFor: 'compiling' stamp: 'tfel 2/1/2012 19:06'!
writePreambleFor: aString on: stream
	"Initial code. Prepare the write stream to hold the rendered string"
	stream
		nextPutAll: '| r00t | r00t := WriteStream on: (String new: ';
		nextPutAll: (aString size / 2) floor printString;
		nextPutAll: ').';
		nextPut: Character cr.! !
